"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = extend;
const aExtendedB = new WeakMap();

function extend(base, extra, hint) {
  const keysA = Object.keys(base);
  const keysB = Object.keys(extra);
  for (const key of keysB) {
    const newValue = extra[key];
    const oldValue = base[key];
    if (aExtendedB.get(newValue) !== oldValue && keysA.indexOf(key) >= 0) {
      throw new Error(`Overwriting key '${key}' is not allowed! ${hint || ""}`);
    }
  }
  const obj = Object.assign({}, base, extra);
  aExtendedB.set(obj, base);
  return obj;
}
//# sourceMappingURL=extend.js.map