"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});


function isValidMutation(Mutation) {
  try {
    if (!Mutation) {
      return false;
    }
    if (Object.keys(Mutation.getFields()).length === 0) {
      return false;
    }
  } catch (e) {
    return false;
  }
  return true;
}

exports.default = async function MutationPlugin(builder) {
  builder.hook("GraphQLSchema", (schema, { newWithHooks, extend, graphql: { GraphQLObjectType } }) => {
    const Mutation = newWithHooks(GraphQLObjectType, {
      name: "Mutation",
      description: "The root mutation type which contains root level fields which mutate data."
    }, { isRootMutation: true }, true);
    if (isValidMutation(Mutation)) {
      return extend(schema, {
        mutation: Mutation
      });
    } else {
      return schema;
    }
  });
};
//# sourceMappingURL=MutationPlugin.js.map